#!/usr/bin/perl -w

package PhotoPub::Global;
require Exporter;
@ISA = qw(Exporter);
@EXPORT_OK = qw($error &init &register_init);

use strict;
use vars qw($error);

my %inits=();

my @stages=('startup','config');

sub register_init {
  my ($stage,$sub)=@_;
  $inits{$stage}=[] unless defined $inits{$stage};
  push(@{$inits{$stage}},$sub);
}

sub init {
  foreach my $stage (@stages) {
    foreach my $initsub (@{$inits{$stage}}) {
      &$initsub();
    }
  }
}

1;
