%define version 0.1.1
# The define of the version macro will be inserted above this line when a
# tarball is made

Name: photopub
Version: %{version}
Release: 1
Group: Applications/Internet
Summary: Publishes photos on the web in a highly customisable manner
License: GPL
Vendor: Project Purple <http://www.earth.li/projectpurple/>
Distribution: Red Hat Linux
Packager: PhotoPub development team <http://urchin.earth.li/projects/photopub/>
URL: http://urchin.earth.li/projects/photopub/
Source: photopub-%{version}.tar.gz
BuildRoot: /var/tmp/photopub-build
BuildRequires: perl
PreReq: patch, diffutils
Requires: apache
BuildArchitectures: noarch

%define __find_requires dist/redhat/find-requires
%define __find_provides dist/redhat/find-provides

%description 

PhotoPub is a perl application for publishing photos, particularly those
taken with a digital camera, on the web. It is designed so that once it is
configured, new photos can be quickly published. Almost every aspect of the
HTML it outputs can be customised.

%prep
%setup

%build
# empty since it's all perl scripts

%install

rm -rf $RPM_BUILD_ROOT
for d in /etc /var/cache/photopub /usr/lib/photopub/PhotoPub \
         /usr/lib/photopub/utils /usr/lib/photopub/cgi-bin \
         /etc/photopub/templates /etc/httpd/conf.d
   do install -d -m755 $RPM_BUILD_ROOT$d
done

dist/mungefile.pl configfind dist/configfind.global < PhotoPub/Config.pm \
   > $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/Config.pm
chmod 644 $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/Config.pm

for d in Handlers Images Ages Annots Cache Global CGIBase CLBase \
         Images Options Utils AlbumHelper RangeHelper
   do install -m 644 PhotoPub/$d.pm $RPM_BUILD_ROOT/usr/lib/photopub/PhotoPub/$d.pm
done

for d in album range display
   do dist/mungefile.pl libsetup dist/libsetup.global < cgi-bin/$d.pl \
         > $RPM_BUILD_ROOT/usr/lib/photopub/cgi-bin/$d.pl
   chmod 755 $RPM_BUILD_ROOT/usr/lib/photopub/cgi-bin/$d.pl
done

for d in checkconfig
   do dist/mungefile.pl libsetup dist/libsetup.global < utils/$d.pl \
        > $RPM_BUILD_ROOT/usr/lib/photopub/utils/$d.pl
   chmod 755 $RPM_BUILD_ROOT/usr/lib/photopub/utils/$d.pl
done

install -m 755 dist/mungefile.pl $RPM_BUILD_ROOT/usr/lib/photopub/utils/

for d in album album-book downwards downwards-fixedwidth across slideshow
   do install -m 644 dist/$d.thtml $RPM_BUILD_ROOT/etc/photopub/templates/$d.thtml
done

install -m 644 dist/photopubrc $RPM_BUILD_ROOT/etc/photopubrc

install -m 644 dist/apache.conf $RPM_BUILD_ROOT/etc/httpd/conf.d/photopub.conf

%post

if [ ! -f /etc/photopub/httpd.conf.nomunge ]; then
   FRAGMENT=`mktemp -q /etc/httpd/conf/httpd.conf.fragment.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   HTTPDCONF=`mktemp -q /etc/httpd/conf/httpd.conf.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   cat > $FRAGMENT << END
#---photopub---

# Changes to this section will be lost if you remove or upgrade PhotoPub
# You can safely move it elsewhere in this file if you wish
# Do not alter the delimiters above and below or bad things will happen!

Include /etc/httpd/conf.d/photopub.conf

#---endphotopub---
END

   if [ -f /etc/photopub/httpd.conf.diff ]; then
      if [ `patch -F 0 --dry-run /etc/httpd/conf/httpd.conf \
             < /etc/photopub/httpd.conf.diff \
             2>&1 | wc -l` -eq 1 ]; then
         patch /etc/httpd/conf/httpd.conf < /etc/photopub/httpd.conf.diff
      fi
      rm -f /etc/photopub/httpd.conf.diff
   fi

   cp -p /etc/httpd/conf/httpd.conf $HTTPDCONF # to get the ownership/perms right
   /usr/lib/photopub/utils/mungefile.pl -a photopub $FRAGMENT \
      < /etc/httpd/conf/httpd.conf > $HTTPDCONF

   mv $HTTPDCONF /etc/httpd/conf/httpd.conf
   rm $FRAGMENT
fi

%preun

if [ ! -f /etc/photopub/httpd.conf.nomunge ]; then

   FRAGMENT=`mktemp -q /etc/httpd/conf/httpd.conf.fragment.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   HTTPDCONF=`mktemp -q /etc/httpd/conf/httpd.conf.XXXXXX`
   if [ $? -ne 0 ]; then
      echo "$0: Can't create temp file, exiting..."
      exit 1
   fi

   cp -p /etc/httpd/conf/httpd.conf $HTTPDCONF # to get the ownership/perms right
   /usr/lib/photopub/utils/mungefile.pl photopub $FRAGMENT \
      < /etc/httpd/conf/httpd.conf > $HTTPDCONF

   diff -u $HTTPDCONF /etc/httpd/conf/httpd.conf > /etc/photopub/httpd.conf.diff \
      && true

   mv $HTTPDCONF /etc/httpd/conf/httpd.conf
   rm $FRAGMENT
fi

%files
%defattr (-,root,root)
%config(noreplace) /etc/photopubrc
/var/cache/photopub
/usr/lib/photopub
%dir /etc/httpd/conf.d
%config(noreplace) /etc/httpd/conf.d/photopub.conf
%config(noreplace) /etc/photopub/templates/*
%doc README doc/*

%changelog
%changelog
* Mon Jan  6 2003 PhotoPub Development Team <photopub-devel@lists.urchin.earth.li 0.1.1-1
- RPM was automatically generated
